<?php
namespace Incoviba\Repository\Contabilidad\Movimiento;

use Incoviba\Common\Define;
use Incoviba\Common\Ideal;
use Incoviba\Common\Implement;
use Incoviba\Common\Implement\Exception\EmptyResult;
use Incoviba\Model;
use Incoviba\Repository;

class Auxiliar extends Ideal\Repository
{
    public function __construct(Define\Connection $connection, protected Repository\Contabilidad\Movimiento $movimientoRepository)
    {
        parent::__construct($connection);
        $this->setTable('movimientos_auxiliares');
    }

    public function create(?array $data = null): Model\Contabilidad\Movimiento\Auxiliar
    {
        $map = (new Implement\Repository\MapperParser(['cargo', 'abono']))
            ->register('movimiento_id', (new Implement\Repository\Mapper())
                ->setProperty('movimiento')
                ->setFunction(function($data) {
                    return $this->movimientoRepository->fetchById($data['movimiento_id']);
                }));
        return $this->parseData(new Model\Contabilidad\Movimiento\Auxiliar(), $data, $map);
    }
    public function save(Define\Model $model): Model\Contabilidad\Movimiento\Auxiliar
    {
        $model->id = $this->saveNew([
            'movimiento_id',
            'cargo',
            'abono'
        ],[
            $model->movimiento->id,
            $model->cargo,
            $model->abono
        ]);
        return $model;
    }
    public function edit(Define\Model $model, array $new_data): Model\Contabilidad\Movimiento\Auxiliar
    {
        return $this->update($model, [
            'movimiento_id',
            'cargo',
            'abono'
        ], $new_data);
    }

    /**
     * @throws EmptyResult
     */
    public function fetchByMovimiento(int $movimiento_id): array
    {
        $query = $this->connection->getQueryBuilder()
            ->select()
            ->from($this->getTable())
            ->where('movimiento_id = :movimiento_id');
        return $this->fetchMany($query, ['movimiento_id' => $movimiento_id]);
    }
}
